## mmseqs2 18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
project(MMseqs CXX C)
message("-- Source Directory: ${CMAKE_CURRENT_SOURCE_DIR}")
message("-- Project Directory: ${PROJECT_SOURCE_DIR}")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(FRAMEWORK_ONLY 0 CACHE BOOL "Framework mode (don't create mmseqs executable)")
set(HAVE_SANITIZER 0 CACHE BOOL "Have sanitizers")
set(INSTALL_UTIL 1 CACHE BOOL "Install utility scripts")
set(VERSION_OVERRIDE "" CACHE STRING "Override version string in help and usage messages")
set(DISABLE_IPS4O 0 CACHE BOOL "Disabling IPS4O sorting library requiring 128-bit compare exchange operations")
set(HAVE_AVX2 0 CACHE BOOL "Have CPU with AVX2")
set(HAVE_SSE4_1 0 CACHE BOOL "Have CPU with SSE4.1")
set(HAVE_SSE2 0 CACHE BOOL "Have CPU with SSE2")
set(HAVE_POWER9 0 CACHE BOOL "Have POWER9 CPU")
set(HAVE_POWER8 0 CACHE BOOL "Have POWER8 CPU")
set(HAVE_ARM8 0 CACHE BOOL "Have ARMv8 CPU")
set(HAVE_S390X 0 CACHE BOOL "Have s390x architecture")
set(NATIVE_ARCH 1 CACHE BOOL "Assume native architecture for SIMD. Use one of the HAVE_* options or set CMAKE_CXX_FLAGS to the appropriate flags if you disable this.")
set(USE_SYSTEM_ZSTD 0 CACHE BOOL "Use zstd provided by system instead of bundled version")
set(ENABLE_CUDA 0 CACHE BOOL "Enable CUDA")
set(FORCE_STATIC_DEPS 0 CACHE BOOL "Force static linking of deps")

if(FORCE_STATIC_DEPS)
    if(ENABLE_CUDA)
        set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so CACHE INTERNAL "" FORCE)
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
    else()
        set(CMAKE_FIND_LIBRARY_SUFFIXES .a CACHE INTERNAL "" FORCE)
        set(CMAKE_LINK_SEARCH_START_STATIC ON CACHE INTERNAL "" FORCE)
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static -static-libgcc -static-libstdc++")
    endif()
    set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "" FORCE)
endif()

if(NOT XCODE AND NOT MSVC AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if (HAVE_SANITIZER)
    include(FindUBSan)
    include(FindASan)
    include(FindMSan)
    include(FindTSan)
endif ()

# find compiler
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message("-- Compiler is clang(++)")
    set(CMAKE_COMPILER_IS_CLANG 1)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message("-- Compiler is GNU ")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9.0")
        message(FATAL_ERROR "Insufficient gcc version")
    endif ()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    message("-- Compiler is icc(++)")
    set(CMAKE_COMPILER_IS_ICC 1)
endif ()

# see https://wiki.debian.org/ArchitectureSpecificsMemo for char signedness
set(MMSEQS_CXX_FLAGS "-fsigned-char")

# SIMD instruction sets support
set(MMSEQS_ARCH "")
if (HAVE_AVX2)
    if (CMAKE_COMPILER_IS_CLANG)
        set(MMSEQS_ARCH "${MMSEQS_ARCH} -mavx2 -mfma -mcx16")
    else ()
        set(MMSEQS_ARCH "${MMSEQS_ARCH} -mavx2 -mfma -mcx16 -Wa,-q")
    endif ()
    set(X64 1 CACHE INTERNAL "")
elseif (HAVE_SSE4_1)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -msse4.1 -mcx16")
    set(X64 1 CACHE INTERNAL "")
elseif (HAVE_SSE2)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -msse2")
    set(DISABLE_IPS4O 1)
    set(X64 1 CACHE INTERNAL "")
elseif (HAVE_POWER9)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -mcpu=power9 -mvsx")
    set(PPC64 1 CACHE INTERNAL "")
elseif (HAVE_POWER8)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -mcpu=power8 -mvsx")
    set(PPC64 1 CACHE INTERNAL "")
elseif (HAVE_ARM8)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -march=armv8-a+simd")
    set(ARM 1 CACHE INTERNAL "")
elseif (HAVE_S390X)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -march=z14 -mzarch -mzvector")
    set(ZARCH 1 CACHE INTERNAL "")
endif ()

if (MMSEQS_ARCH)
    set(NATIVE_ARCH 0 CACHE INTERNAL "")
endif ()

if (NATIVE_ARCH)
    if (CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*|aarch64.*|AARCH64.*)")
        set(ARM 1 CACHE INTERNAL "")
    elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
        set(PPC64 1 CACHE INTERNAL "")
    elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "amd64|AMD64")
        set(X64 1 CACHE INTERNAL "")
    elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "x86|X86")
        set(X86 1 CACHE INTERNAL "")
    elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390")
        set(ZARCH 1 CACHE INTERNAL "")
    elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^sparc")
        set(SPARC 1 CACHE INTERNAL "")
    else ()
        message(WARNING "CPU without native SIMD instructions. Performance will be bad.")
    endif ()
    if (EMSCRIPTEN)
        set(MMSEQS_ARCH "-msimd128 -s WASM=1 -s ASSERTIONS=1")
    elseif (X86 OR X64)
        include(CheckSSEFeatures)
        if (NOT HAVE_SSE4_1_EXTENSIONS)
            if (NOT HAVE_SSE2_EXTENSIONS)
                message(FATAL_ERROR "At least SSE2 is needed to compile")
            endif ()
            message(WARNING "At least SSE4.1 is needed for best performance")
        endif ()
        # clang has a problem with march=native on travis
        if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.0.0")
            set(MMSEQS_ARCH "${SSE_FLAGS}")
        else()
            set(MMSEQS_ARCH "-march=native")
        endif()
    elseif (PPC64 OR ARM)
        set(MMSEQS_ARCH "-mcpu=native")
    elseif (ZARCH)
        set(MMSEQS_ARCH "-mcpu=native -mzvector")
    else ()
        set(MMSEQS_ARCH "-march=native")
    endif ()
endif ()

if (ARM AND CMAKE_COMPILER_IS_CLANG AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 20.1.5)
    message("-- Setting -DAVX2 ON ARM")
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -DAVX2")
endif ()

set(MMSEQS_ARCH ${MMSEQS_ARCH} CACHE INTERNAL "")

if (NOT (MMSEQS_ARCH STREQUAL ""))
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} ${MMSEQS_ARCH}")
endif ()

if (CYGWIN OR ARM OR PPC64)
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D_GNU_SOURCE=1")
endif ()

if (CMAKE_COMPILER_IS_ICC)
    # default -fp-model results in inconsistent results in profile search
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -fp-model precise")
endif ()

# Apple specific features
if (APPLE)
    # macOS SDK started using _Atomic (in ucred.h) which g++ does not support
    # __APPLE_API_STRICT_CONFORMANCE makes sysctl.h not include apis like ucred.h
    # See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=89864
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D__APPLE_API_STRICT_CONFORMANCE")
endif ()

if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D_WITH_GETLINE")
endif ()

if (CYGWIN)
    # default cygwin allocator (dlmalloc) locks on every allocation and destroys MT performance
    add_subdirectory(lib/nedmalloc)
    # IPS4O seems to deadlock on cygwin
    set(DISABLE_IPS4O 1)
endif()

if ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
        OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.1.0"))
    # clang before v5 throws compile errors on ips4o
    set(DISABLE_IPS4O 1)
endif ()

if (PPC64 OR SPARC OR ZARCH)
    # FIXME: investigate why on ppc the regression seems to fail randomly
    set(DISABLE_IPS4O 1)
endif ()

set(MMSEQS_C_FLAGS "${MMSEQS_CXX_FLAGS}")
set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -std=c++1y")
# Compiler-specific features
# if (CMAKE_COMPILER_IS_CLANG AND (NOT EMSCRIPTEN))
#     set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
#     set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
#     set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -stdlib=libc++")
# endif ()

if (USE_SYSTEM_ZSTD)
    include(FindPackageHandleStandardArgs)
    find_path(ZSTD_INCLUDE_DIRS NAMES zstd.h REQUIRED)
    # We use ZSTD_findDecompressedSize which is only available with ZSTD_STATIC_LINKING_ONLY
    find_library(ZSTD_LIBRARIES NAMES libzstd.a libzstd_static REQUIRED)
    find_package_handle_standard_args(ZSTD DEFAULT_MSG ZSTD_LIBRARIES ZSTD_INCLUDE_DIRS)
    mark_as_advanced(ZSTD_LIBRARIES ZSTD_INCLUDE_DIRS)
    include_directories(${ZSTD_INCLUDE_DIRS})
else ()
    # We use ZSTD_findDecompressedSize which is only available with ZSTD_STATIC_LINKING_ONLY
    set(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd")
    set(CMAKE_INSTALL_LIBDIR bin)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd/build/cmake/CMakeModules")
    option(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" OFF)
    option(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
    option(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
    option(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" OFF)
    option(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
    option(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)
    option(ZSTD_BUILD_TESTS "BUILD TESTS" OFF)
    include_directories(lib/zstd/lib)
    add_subdirectory(lib/zstd/build/cmake/lib EXCLUDE_FROM_ALL)
    set_target_properties(libzstd_static PROPERTIES COMPILE_FLAGS "${MMSEQS_C_FLAGS}" LINK_FLAGS "${MMSEQS_C_FLAGS}")
    set(ZSTD_LIBRARIES libzstd_static)
endif()

# tinyexpr
include_directories(lib/tinyexpr)
add_subdirectory(lib/tinyexpr EXCLUDE_FROM_ALL)

# microtar
include_directories(lib/microtar)
add_subdirectory(lib/microtar)

# tantan
include_directories(lib/tantan)
add_subdirectory(lib/tantan)

# simde
include_directories(lib/simde)

include_directories(lib)
include_directories(lib/simd)
include_directories(lib/alp)
include_directories(lib/ksw2)
include_directories(lib/xxhash)
if (NOT DISABLE_IPS4O)
    include_directories(lib/ips4o)
endif ()

# libmarv
if (ENABLE_CUDA)
    set(LIBRARY_ONLY 1 CACHE INTERNAL "" FORCE)
    include_directories(lib/libmarv/src)
    add_subdirectory(lib/libmarv/src EXCLUDE_FROM_ALL)
endif ()

add_subdirectory(lib/alp)
add_subdirectory(lib/ksw2)
add_subdirectory(data)
add_subdirectory(src)
if (NOT FRAMEWORK_ONLY AND INSTALL_UTIL)
    add_subdirectory(util)
endif ()

=== data/CMakeLists.txt ===
include(MMseqsResourceCompiler)


add_subdirectory(resources)
add_subdirectory(workflow)
set(GENERATED_MATRICES
        VTML80.out
        VTML40.out
        nucleotide.out
        blosum62.out
        PAM30.out
        )

set(GENERATED_OUTPUT_HEADERS "")
FOREACH(INPUT_FILE ${GENERATED_MATRICES} ${GENERATED_RESOURCES} ${GENERATED_WORKFLOWS})
    compile_resource(${INPUT_FILE} OUTPUT_FILE)
    list(APPEND GENERATED_OUTPUT_HEADERS "${OUTPUT_FILE}")
ENDFOREACH()

add_custom_target(generated ALL DEPENDS ${GENERATED_OUTPUT_HEADERS})

=== src/CMakeLists.txt ===
set(HAVE_MPI 0 CACHE BOOL "Have MPI")
set(HAVE_TESTS 0 CACHE BOOL "Have Tests")
set(HAVE_SHELLCHECK 1 CACHE BOOL "Have ShellCheck")
set(HAVE_GPROF 0 CACHE BOOL "Have GPROF Profiler")
set(ENABLE_WERROR 0 CACHE BOOL "Enable Warnings as Errors")
#set(DISABLE_LTO 0 CACHE BOOL "Disable link-time optimization in non-debug builds")
set(REQUIRE_OPENMP 1 CACHE BOOL "Require availability of OpenMP")
set(ATOMIC_LIB_OVERRIDE "" CACHE PATH "Override path to libatomic")

include(AppendTargetProperty)

add_subdirectory(alignment)
add_subdirectory(clustering)
add_subdirectory(commons)
add_subdirectory(linclust)
add_subdirectory(multihit)
add_subdirectory(prefiltering)
add_subdirectory(taxonomy)
add_subdirectory(util)
add_subdirectory(workflow)

add_library(mmseqs-framework
        $<TARGET_OBJECTS:alp>
        $<TARGET_OBJECTS:ksw2>
        ${alignment_header_files}
        ${alignment_source_files}
        ${clustering_header_files}
        ${clustering_source_files}
        ${commons_header_files}
        ${commons_source_files}
        ${prefiltering_header_files}
        ${prefiltering_source_files}
        ${multihit_header_files}
        ${multihit_source_files}
        ${taxonomy_header_files}
        ${taxonomy_source_files}
        ${linclust_source_files}
        ${util_header_files}
        ${util_source_files}
        ${workflow_source_files}
        CommandDeclarations.h
        MMseqsBase.cpp
        )

target_include_directories(mmseqs-framework PUBLIC ${CMAKE_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC ${PROJECT_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC alignment)
target_include_directories(mmseqs-framework PUBLIC clustering)
target_include_directories(mmseqs-framework PUBLIC commons)
target_include_directories(mmseqs-framework PUBLIC multihit)
target_include_directories(mmseqs-framework PUBLIC prefiltering)
target_include_directories(mmseqs-framework PUBLIC linclust)
target_include_directories(mmseqs-framework PUBLIC taxonomy)
target_include_directories(mmseqs-framework PUBLIC util)
target_include_directories(mmseqs-framework PUBLIC .)

add_dependencies(mmseqs-framework generated)

#if (NOT DISABLE_LTO)
#    string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
#    if (uppercase_CMAKE_BUILD_TYPE MATCHES "^(RELEASE|RELWITHDEBINFO|MINSIZEREL)$")
#        cmake_policy(SET CMP0069 NEW)
#        include(CheckIPOSupported)
#        check_ipo_supported(RESULT IPO_SUPPORTED)
#        if (IPO_SUPPORTED)
#            set_property(TARGET mmseqs-framework PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
#        endif ()
#    endif ()
#endif ()

append_target_property(mmseqs-framework COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
append_target_property(mmseqs-framework LINK_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
if (NOT EMSCRIPTEN)
    append_target_property(mmseqs-framework COMPILE_FLAGS -fno-exceptions)
    append_target_property(mmseqs-framework LINK_FLAGS -fno-exceptions)
endif()

if (ENABLE_WERROR)
    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror -Wno-unused-command-line-argument)
    append_target_property(mmseqs-framework LINK_FLAGS -Werror -Wno-unused-command-line-argument)
endif()

# needed for concat.h
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>

        int main() {
          FILE* tmpf = tmpfile();
          int input_desc = fileno(tmpf);
          int test = posix_fadvise(input_desc, 0, 0, POSIX_FADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_FADVISE)
if (HAVE_POSIX_FADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_FADVISE=1)
endif ()

check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>
        #include <sys/mman.h>

        int main() {
          FILE* tmpf = tmpfile();
          void *tmp = mmap(NULL, 32, PROT_READ, MAP_SHARED, fileno(tmpf), 0);
          int test = posix_madvise(tmp, 32, POSIX_MADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_MADVISE)
if (HAVE_POSIX_MADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_MADVISE=1)
endif ()

if (NOT DISABLE_IPS4O)
    if (ATOMIC_LIB_OVERRIDE)
        add_library(LibAtomic STATIC IMPORTED)
        set_target_properties(LibAtomic PROPERTIES IMPORTED_LOCATION ${ATOMIC_LIB_OVERRIDE})
        target_link_libraries(mmseqs-framework LibAtomic)
        target_compile_definitions(mmseqs-framework PUBLIC -DENABLE_IPS4O=1)
        message("-- IPS4O sorting forced with ${ATOMIC_LIB_OVERRIDE}")
    else()
        find_package(Atomic)
        if (ATOMIC_FOUND)
            target_link_libraries(mmseqs-framework ${ATOMIC_LIBRARIES})
            target_compile_definitions(mmseqs-framework PUBLIC -DENABLE_IPS4O=1)
            message("-- IPS4O sorting works")
        else ()
            message("-- OMPTL sorting fallback")
        endif ()
    endif ()
else ()
    message("-- OMPTL sorting fallback")
endif ()

target_link_libraries(mmseqs-framework tinyexpr ${ZSTD_LIBRARIES} microtar tantan)
# if (CYGWIN)
#     target_link_libraries(mmseqs-framework nedmalloc)
# endif ()

if (EMSCRIPTEN)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1 -DHAVE_BZLIB=1)
    append_target_property(mmseqs-framework COMPILE_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
    append_target_property(mmseqs-framework LINK_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
else ()
find_package(ZLIB QUIET)
if (ZLIB_FOUND)
    message("-- Found ZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lz)
    set(CMAKE_REQUIRED_INCLUDES ${ZLIB_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${ZLIB_LIBRARIES})
    check_cxx_source_compiles("
        #include <zlib.h>
        int main() { gzFile file; return 0; }"
        HAVE_ZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_ZLIB_CHECK)
        message("-- ZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${ZLIB_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1)
        target_link_libraries(mmseqs-framework ${ZLIB_LIBRARIES})
    else ()
        message("-- ZLIB does not work")
    endif()
else ()
    message("-- Could not find ZLIB")
endif ()

find_package(BZip2 QUIET)
if (BZIP2_FOUND)
    message("-- Found BZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lbz2)
    set(CMAKE_REQUIRED_INCLUDES ${BZIP_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${BZIP2_LIBRARIES})
    check_cxx_source_compiles("
        #include <bzlib.h>
        int main() { bz_stream stream; return 0; }"
        HAVE_BZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_BZLIB_CHECK)
        message("-- BZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${BZIP_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_BZLIB=1)
        target_link_libraries(mmseqs-framework ${BZIP2_LIBRARIES})
    else ()
        message("-- BZLIB does not work")
    endif()
else ()
    message("-- Could not find BZLIB")
endif ()
endif ()

# MPI
if (HAVE_MPI)
    find_package(MPI REQUIRED)
    if (MPI_FOUND)
        message("-- Found MPI")
        target_include_directories(mmseqs-framework PUBLIC ${MPI_INCLUDE_PATH})
        #Hack (OMPI_SKIP_MPICXX=1): https://github.com/open-mpi/ompi/issues/5157#issuecomment-388495496
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_MPI=1 -DOMPI_SKIP_MPICXX=1)
        target_link_libraries(mmseqs-framework ${MPI_LIBRARIES})
        append_target_property(mmseqs-framework COMPILE_FLAGS ${MPI_COMPILE_FLAGS})
        append_target_property(mmseqs-framework LINK_FLAGS ${MPI_LINK_FLAGS})
    endif ()
endif ()


find_package(OpenMP QUIET)
if (OPENMP_FOUND)
    message("-- Found OpenMP")
    target_compile_definitions(mmseqs-framework PUBLIC -DOPENMP=1)
    # hack: remove pthread from openmp deps, it gets linked correctly by cuda later
    if (FORCE_STATIC_DEPS AND ENABLE_CUDA)
        set(FILTERED_LIBRARIES "")
        foreach (LIB ${OpenMP_CXX_LIBRARIES})
            if (NOT LIB MATCHES "pthread")
                list(APPEND FILTERED_LIBRARIES ${LIB})
            endif ()
        endforeach ()
        set(OpenMP_CXX_LIBRARIES ${FILTERED_LIBRARIES})
    endif ()
    target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
    target_include_directories(mmseqs-framework PUBLIC ${OpenMP_CXX_INCLUDE_DIRS})
    append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
    append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
elseif (REQUIRE_OPENMP)
    message(FATAL_ERROR "-- Could not find OpenMP. Skip check with -DREQUIRE_OPENMP=0.")
endif ()

if (HAVE_GPROF)
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-pg GPROF_FOUND)
    if (GPROF_FOUND)
        append_target_property(mmseqs-framework COMPILE_FLAGS -pg)
        append_target_property(mmseqs-framework LINK_FLAGS -pg)
    else ()
        message(FATAL_ERROR "-- Could not find GPROF")
    endif ()
endif ()

if (ENABLE_CUDA)
    find_package(CUDAToolkit REQUIRED)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_CUDA=1)
    target_link_libraries(mmseqs-framework marv)
    if (FORCE_STATIC_DEPS)
        # link to rt explicitly so it doesn't get statically compiled and adds GLIBC_PRIVATE symbols
        target_link_libraries(mmseqs-framework rt)
        # remove librt.a which introduces GLIBC_PRIVATE symbols
        get_property(linked_libraries TARGET CUDA::cudart_static_deps PROPERTY INTERFACE_LINK_LIBRARIES)
        set(FILTERED_LIBRARIES "")
        foreach (LIB ${linked_libraries})
            if (NOT LIB MATCHES ".*librt\\.a$")
                list(APPEND FILTERED_LIBRARIES ${LIB})
            endif ()
        endforeach ()
        set_target_properties(CUDA::cudart_static_deps PROPERTIES INTERFACE_LINK_LIBRARIES "${FILTERED_LIBRARIES}")
    endif ()
    target_link_libraries(mmseqs-framework CUDA::cudart_static)
endif ()

if (NOT FRAMEWORK_ONLY)
    include(MMseqsSetupDerivedTarget)
    add_subdirectory(version)
    set(mmseqs_source_files mmseqs.cpp)

    add_executable(mmseqs${EXE_SUFFIX} ${mmseqs_source_files})
    mmseqs_setup_derived_target(mmseqs${EXE_SUFFIX})
    target_link_libraries(mmseqs${EXE_SUFFIX} version)
    install(TARGETS mmseqs${EXE_SUFFIX} DESTINATION bin)

    if (HAVE_TESTS)
        add_subdirectory(test)
    endif ()
endif ()

=== util/CMakeLists.txt ===
install(PROGRAMS
        bash-completion.sh
        DESTINATION util
        )

=== data/resources/CMakeLists.txt ===
set(GENERATED_RESOURCES
        resources/CovSeqidQscPercMinDiag.lib
        resources/CovSeqidQscPercMinDiagTargetCov.lib
        resources/ExpOpt3_8_polished.cs32.lib
        resources/Library255_may17.lib
        resources/libPolished_8.lib
        resources/cs219.lib
        resources/krona_prelude.html
        resources/result_viz_prelude.html.zst
        resources/K4000.crf
        PARENT_SCOPE
        )

=== data/workflow/CMakeLists.txt ===
set(GENERATED_WORKFLOWS
        workflow/easysearch.sh
        workflow/easycluster.sh
        workflow/easytaxonomy.sh
        workflow/easyrbh.sh
        workflow/blastp.sh
        workflow/blastpgp.sh
        workflow/map.sh
        workflow/rbh.sh
        workflow/linclust.sh
        workflow/clustering.sh
        workflow/cascaded_clustering.sh
        workflow/update_clustering.sh
        workflow/searchtargetprofile.sh
        workflow/createindex.sh
        workflow/createtaxdb.sh
        workflow/translated_search.sh
        workflow/taxpercontig.sh
        workflow/multihitdb.sh
        workflow/multihitsearch.sh
        workflow/enrich.sh
        workflow/blastn.sh
        workflow/searchslicedtargetprofile.sh
        workflow/taxonomy.sh
        workflow/linsearch.sh
        workflow/databases.sh
        workflow/pickconsensusrep.sh
        workflow/nucleotide_clustering.sh
        workflow/iterativepp.sh
        workflow/tsv2exprofiledb.sh
        PARENT_SCOPE
        )

=== lib/alp/CMakeLists.txt ===
add_library(alp OBJECT
        sls_basic.hpp
        njn_dynprogprob.cpp
        njn_random.cpp
        sls_pvalues.hpp
        njn_random.hpp
        njn_integer.hpp
        njn_doubletype.hpp
        njn_dynprogprob.hpp
        njn_dynprogproblim.hpp
        sls_alp_sim.hpp
        njn_dynprogprobproto.cpp
        njn_localmaxstatutil.hpp
        njn_localmaxstat.cpp
        njn_localmaxstat.hpp
        njn_matrix.hpp
        njn_localmaxstatmatrix.cpp
        sls_alp_regression.hpp
        sls_alp_sim.cpp
        sls_pvalues.cpp
        njn_root.hpp
        njn_dynprogproblim.cpp
        sls_alignment_evaluer.cpp
        njn_localmaxstatmatrix.hpp
        sls_alp_regression.cpp
        njn_dynprogprobproto.hpp
        sls_alp.cpp
        njn_approx.hpp
        njn_memutil.hpp
        njn_localmaxstatutil.cpp
        njn_function.hpp
        njn_ioutil.hpp
        sls_basic.cpp
        njn_uniform.hpp
        sls_alignment_evaluer.hpp
        njn_vector.hpp
        sls_alp_data.cpp
        sls_alp_data.hpp
        njn_ioutil.cpp
        sls_alp.hpp
        sls_normal_distr_array.hpp
        )
set_target_properties(alp PROPERTIES COMPILE_FLAGS "${MMSEQS_CXX_FLAGS} -w" LINK_FLAGS "${MMSEQS_CXX_FLAGS} -w")

=== lib/ksw2/CMakeLists.txt ===
add_library(ksw2 OBJECT
        ksw2.h
        ksw2_extz2_sse.cpp
        )
set_target_properties(ksw2 PROPERTIES COMPILE_FLAGS "${MMSEQS_CXX_FLAGS}" LINK_FLAGS "${MMSEQS_CXX_FLAGS}")

=== lib/libmarv/Makefile ===
# settings
DIALECT      = -std=c++17
OPTIMIZATION = -O3 -g
WARNINGS     = -Xcompiler="-Wall -Wextra"

# NVCC_FLAGS   = -DCUDASW_DEBUG_CHECK_CORRECTNESS -arch=native -lineinfo --expt-relaxed-constexpr -rdc=true --extended-lambda -lnvToolsExt -Xcompiler="-fopenmp" #-res-usage #-Xptxas "-v"
NVCC_FLAGS   = -arch=native -lineinfo --expt-relaxed-constexpr -rdc=true --extended-lambda -lnvToolsExt -Xcompiler="-fopenmp" #-res-usage #-Xptxas "-v"


LDFLAGS      = -Xcompiler="-pthread"  $(NVCC_FLAGS) -lz
COMPILER     = nvcc
ARTIFACT     = align

BUILDDIR = build

MAKEDB = makedb
MODIFYDB = modifydb
GRIDSEARCH = gridsearch
TILECONFIGSEARCH = tileconfigsearch

$(shell mkdir -p $(BUILDDIR))

# make targets
.PHONY: clean

release: $(ARTIFACT) $(MAKEDB) $(TILECONFIGSEARCH)


clean :
	rm -f $(BUILDDIR)/*
	rm -f $(ARTIFACT)
	rm -f $(MAKEDB)
	rm -f $(TILECONFIGSEARCH)

# compiler call
COMPILE = $(COMPILER) $(NVCC_FLAGS) $(DIALECT) $(OPTIMIZATION) $(WARNINGS) -c $< -o $@

CUDASW_OBJS =  $(BUILDDIR)/sequence_io.o $(BUILDDIR)/dbdata.o $(BUILDDIR)/options.o $(BUILDDIR)/blosum.o $(BUILDDIR)/pssmkernels_smithwaterman_instantiation_float.o $(BUILDDIR)/pssmkernels_smithwaterman_instantiation_dpx.o $(BUILDDIR)/pssmkernels_gapless_instantiation_half2.o $(BUILDDIR)/pssmkernels_gapless_instantiation_dpx.o $(BUILDDIR)/pssmkernels_gapless_instantiation_half2_kernelparamzero.o $(BUILDDIR)/pssmkernels_gapless_instantiation_dpx_kernelparamzero.o

# link object files into executable
$(ARTIFACT): $(BUILDDIR)/main.o $(CUDASW_OBJS)
	$(COMPILER) $^ -o $(ARTIFACT) $(LDFLAGS)

$(TILECONFIGSEARCH): $(BUILDDIR)/tileconfigsearch.o $(CUDASW_OBJS)
	$(COMPILER) $^ -o $(TILECONFIGSEARCH) $(LDFLAGS)	

$(MAKEDB): $(BUILDDIR)/makedb.o $(BUILDDIR)/sequence_io.o $(BUILDDIR)/dbdata.o
	$(COMPILER) $^ -o $(MAKEDB) $(LDFLAGS)



$(BUILDDIR)/tileconfigsearch.o : src/tileconfigsearch.cu src/sequence_io.h src/length_partitions.hpp src/dbdata.hpp src/cudasw4.cuh src/kernels.cuh src/convert.cuh src/blosum.hpp src/types.hpp src/pssm.cuh src/pssmkernels_gapless.cuh src/pssmkernels_smithwaterman.cuh src/gapless_kernel_config.cuh
	$(COMPILE)

$(BUILDDIR)/main.o : src/main.cu src/sequence_io.h src/length_partitions.hpp src/dbdata.hpp src/cudasw4.cuh src/kernels.cuh src/convert.cuh src/blosum.hpp src/types.hpp src/pssm.cuh src/pssmkernels_gapless.cuh src/pssmkernels_smithwaterman.cuh src/gapless_kernel_config.cuh
	$(COMPILE)

$(BUILDDIR)/sequence_io.o : src/sequence_io.cpp src/sequence_io.h
	$(COMPILE)

$(BUILDDIR)/dbdata.o : src/dbdata.cpp src/dbdata.hpp src/mapped_file.hpp src/sequence_io.h src/length_partitions.hpp
	$(COMPILE)

$(BUILDDIR)/options.o : src/options.cpp src/options.hpp src/types.hpp
	$(COMPILE)

$(BUILDDIR)/blosum.o : src/blosum.cu src/blosum.hpp
	$(COMPILE)

$(BUILDDIR)/pssmkernels_gapless_instantiation_half2.o : src/pssmkernels_gapless_instantiation_half2.cu src/pssmkernels_gapless.cuh src/convert.cuh src/util.cuh
	$(COMPILE)

$(BUILDDIR)/pssmkernels_gapless_instantiation_dpx.o : src/pssmkernels_gapless_instantiation_dpx.cu src/pssmkernels_gapless.cuh src/convert.cuh src/util.cuh
	$(COMPILE)	

$(BUILDDIR)/pssmkernels_gapless_instantiation_half2_kernelparamzero.o : src/pssmkernels_gapless_instantiation_half2_kernelparamzero.cu src/pssmkernels_gapless.cuh src/convert.cuh src/util.cuh
	$(COMPILE)

$(BUILDDIR)/pssmkernels_gapless_instantiation_dpx_kernelparamzero.o : src/pssmkernels_gapless_instantiation_dpx_kernelparamzero.cu src/pssmkernels_gapless.cuh src/convert.cuh src/util.cuh
	$(COMPILE)	

$(BUILDDIR)/pssmkernels_smithwaterman_instantiation_float.o : src/pssmkernels_smithwaterman_instantiation_float.cu src/pssmkernels_smithwaterman.cuh src/convert.cuh src/util.cuh
	$(COMPILE)

$(BUILDDIR)/pssmkernels_smithwaterman_instantiation_dpx.o : src/pssmkernels_smithwaterman_instantiation_dpx.cu src/pssmkernels_smithwaterman.cuh src/convert.cuh src/util.cuh
	$(COMPILE)

$(BUILDDIR)/makedb.o : src/makedb.cpp src/dbdata.hpp src/sequence_io.h
	$(COMPILE)

=== lib/microtar/CMakeLists.txt ===
add_library(microtar microtar.h microtar.c)
set_target_properties(microtar PROPERTIES COMPILE_FLAGS "${MMSEQS_C_FLAGS}" LINK_FLAGS "${MMSEQS_C_FLAGS}")

=== lib/nedmalloc/CMakeLists.txt ===
add_library(nedmalloc nedmalloc.c)
set_target_properties(nedmalloc
        PROPERTIES
                COMPILE_FLAGS "-DREPLACE_SYSTEM_ALLOCATOR -DWIN32 -DNO_MALLINFO=1 ${MMSEQS_CXX_FLAGS} -w"
                LINK_FLAGS "-DREPLACE_SYSTEM_ALLOCATOR -DWIN32 -DNO_MALLINFO=1 ${MMSEQS_CXX_FLAGS} -w")

=== lib/tantan/CMakeLists.txt ===
add_library(tantan tantan.cpp tantan.h mcf_simd.h)
set_target_properties(tantan PROPERTIES COMPILE_FLAGS "${MMSEQS_CXX_FLAGS}" LINK_FLAGS "${MMSEQS_CXX_FLAGS}")

## mmseqs2 18-8cc5c+ds

=== debian/changelog ===
mmseqs2 (18-8cc5c+ds-1) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * d/control: simplify architecture specification by using the
    provisions from the architecture-properties package.
  * d/salsi-ci.yml: skip i386 build, add link to salsa-ci docs.

  [ Andreas Tille ]
  * Fix build with CMake 4
    Closes: #1113291
  * d/watch: version=5
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 19 Oct 2025 21:28:28 +0200

=== debian/control ===
Source: mmseqs2
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Shayan Doust <hello@shayandoust.me>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 cmake,
 architecture-is-64-bit,
 architecture-is-little-endian,
 libgzstream-dev,
 libzstd-dev,
 zlib1g-dev,
 libbz2-dev,
 libsimde-dev,
 libxxhash-dev,
Vcs-Browser: https://salsa.debian.org/med-team/mmseqs2
Vcs-Git: https://salsa.debian.org/med-team/mmseqs2.git
Homepage: https://github.com/soedinglab/MMseqs2
Rules-Requires-Root: no

Package: mmseqs2
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Built-Using:
 ${simde:Built-Using},
Description: ultra fast and sensitive protein search and clustering
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwin) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

Package: mmseqs2-examples
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 mmseqs2,
Description: optional resources for the mmseqs2 package
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwim) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

binprefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr/bin
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

cmake_flags=-DUSE_SYSTEM_ZSTD=1 -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0 -DCMAKE_POLICY_VERSION_MINIMUM=3.5

%:
	dh $@

AMD64_SIMD_LEVELS=avx2 avx sse4.1 ssse3 sse3

override_dh_auto_configure-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),export CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" && export CFLAGS="$(CFLAGS) -m$(SIMD)" && \
	        dh_auto_configure --builddirectory build_$(SIMD) -- -DEXE_SUFFIX=-$(SIMD) $(cmake_flags) && ) true
	export CXXFLAGS="$(CXXFLAGS)" && export CFLAGS="$(CFLAGS)" && \
		dh_auto_configure --builddirectory build_plain -- -DEXE_SUFFIX=-plain $(cmake_flags)
else
	dh_auto_configure -- $(cmake_flags)
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p $(binprefix)
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_build --builddirectory build_$(SIMD) && ) true
else
	dh_auto_build
endif

override_dh_auto_build-indep:

override_dh_auto_install-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install -pmmseqs2 debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_install --builddirectory build_$(SIMD) && ) true
	dh_install -pmmseqs2 usr/bin/mmseqs-* usr/bin/
	set -e && cd $(binprefix) \
		&& for prog in mmseqs ; do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	dh_auto_install
	dh_install -pmmseqs2 usr/bin/mmseqs usr/bin/
endif

override_dh_auto_install-indep:

override_dh_auto_clean:
ifeq (amd64,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_clean --builddirectory build_$(SIMD) && ) true
	dh_auto_clean --builddirectory build_plain
endif
	dh_auto_clean
	rm -Rf build-*

override_dh_install-arch:
	dh_install --arch
	mkdir -p debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test/
	#cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2/

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2/usr/lib/mmseqs2/test/CMakeFiles \
		debian/mmseqs2/usr/lib/mmseqs2/test/*.cmake \
		debian/mmseqs2/usr/lib/mmseqs2/test/Makefile

override_dh_install-indep:
	dh_install --indep

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/*.lib \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiag.out \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiagTargetCov.out

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
Version: 5

Source: https://github.com/soedinglab/MMseqs2/tags
Matching-Pattern: .*/v?@ANY_VERSION@@ARCHIVE_EXT@
Filename-Mangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Repack-Suffix: +ds
Dversion-Mangle: auto
